diff --git a/lib/igt_aux.c b/lib/igt_aux.c
index 180c274..c0ea0e2 100644
--- a/lib/igt_aux.c
+++ b/lib/igt_aux.c
@@ -59,7 +59,7 @@
 
 /**
  * SECTION:igt_aux
- * @short_description: Auxiliary libararies and support functions
+ * @short_description: Auxiliary libraries and support functions
  * @title: i-g-t aux
  * @include: igt_aux.h
  *
@@ -222,7 +222,7 @@ void igt_permute_array(void *array, unsigned size,
  *
  * This function draws a progress indicator, which is useful for running
  * long-winded tests manually on the console. To avoid spamming logfiles in
- * automated runs the progress indicator is supressed when not running on a
+ * automated runs the progress indicator is suppressed when not running on a
  * terminal.
  */
 void igt_progress(const char *header, uint64_t i, uint64_t total)
@@ -325,11 +325,11 @@ void igt_system_suspend_autoresume(void)
 }
 
 /**
- * igt_drop_roo:
+ * igt_drop_root:
  *
- * Drop root priviledges and make sure it actually worked. Useful for tests
+ * Drop root privileges and make sure it actually worked. Useful for tests
  * which need to check security constraints. Note that this should only be
- * called from manually forked processes, since the lack of root priviledges
+ * called from manually forked processes, since the lack of root privileges
  * will wreak havoc with the automatic cleanup handlers.
  */
 void igt_drop_root(void)
@@ -350,7 +350,7 @@ void igt_drop_root(void)
  * Waits for a key press when run interactively and when the corresponding debug
  * key is set in the IGT_DEBUG_INTERACTIVE environment variable. Multiple keys
  * can be specified as a comma-separated list or alternatively "all" if a wait
- * should happen for all keys.  When not connected to a terminal the enviroment
+ * should happen for all keys.  When not connected to a terminal the environment
  * setting is ignored and execution immediately continues.
  *
  * This is useful for display tests where under certain situation manual
diff --git a/lib/igt_core.c b/lib/igt_core.c
index 5d41468..f2b4560 100644
--- a/lib/igt_core.c
+++ b/lib/igt_core.c
@@ -67,7 +67,7 @@
  * @title: i-g-t core
  * @include: igt_core.h
  *
- * This libary implements the core of the i-g-t test support infrastructure.
+ * This library implements the core of the i-g-t test support infrastructure.
  * Main features are the subtest enumeration, cmdline option parsing helpers for
  * subtest handling and various helpers to structure testcases with subtests and
  * handle subtest test results.
@@ -141,9 +141,9 @@
  *   conditions, but instead such assumptions should be written in a declarative
  *   style.  Use one of the many macros which encapsulate i-g-t's implicit
  *   control flow.  Pick the most suitable one to have as much debug output as
- *   possible without polluting the code unecessarily. For example
+ *   possible without polluting the code unnecessarily. For example
  *   igt_assert_cmpint() for comparing integers or do_ioctl() for running ioctls
- *   and checking their results.  Feel free to add new ones to the libary or
+ *   and checking their results.  Feel free to add new ones to the library or
  *   wrap up a set of checks into a private function to further condense your
  *   test logic.
  *
@@ -197,7 +197,7 @@
  * run as non-root and doesn't require the i915 driver to be loaded (or any
  * intel gpu to be present). Then individual subtests can be run with
  * "--run-subtest". Usage help for tests with subtests can be obtained with the
- * "--help" commandline option.
+ * "--help" command line option.
  */
 
 static unsigned int exit_handler_count;
@@ -733,7 +733,7 @@ void __igt_skip_check(const char *file, const int line,
 /**
  * igt_success:
  *
- * Complete a (subtest) as successfull
+ * Complete a (subtest) as successful
  *
  * This bails out of a subtests and marks it as successful. For global tests it
  * it won't bail out of anything.
@@ -1041,9 +1041,9 @@ bool __igt_fork(void)
  * Wait for all children forked with igt_fork.
  *
  * The magic here is that exit codes from children will be correctly propagated
- * to the main thread, including the relevant exitcode if a child thread failed.
- * Of course if multiple children failed with differen exitcodes the resulting
- * exitcode will be non-deterministic.
+ * to the main thread, including the relevant exit code if a child thread failed.
+ * Of course if multiple children failed with different exit codes the resulting
+ * exit code will be non-deterministic.
  *
  * Note that igt_skip() will not be forwarded, feature tests need to be done
  * before spawning threads with igt_fork().
@@ -1282,8 +1282,8 @@ void igt_enable_exit_handler(void)
  * igt_run_in_simulation:
  *
  * This function can be used to select a reduced test set when running in
- * simulation enviroments. This i-g-t mode is selected by setting the
- * INTEL_SIMULATION enviroment variable to 1.
+ * simulation environments. This i-g-t mode is selected by setting the
+ * INTEL_SIMULATION environment variable to 1.
  *
  * Returns: True when run in simulation mode, false otherwise.
  */
@@ -1334,7 +1334,7 @@ void igt_skip_on_simulation(void)
  * to stderr and the test runner should treat this as an intermediate result
  * between SUCESS and FAILURE.
  *
- * The log level can be set through the IGT_LOG_LEVEL enviroment variable with
+ * The log level can be set through the IGT_LOG_LEVEL environment variable with
  * values "debug", "info", "warn" and "none". By default verbose debug message
  * are disabled. "none" completely disables all output and is not recommended
  * since crucial issues only reported at the IGT_LOG_WARN level are ignored.
diff --git a/lib/igt_core.h b/lib/igt_core.h
index d74cbf9..1e7bac8 100644
--- a/lib/igt_core.h
+++ b/lib/igt_core.h
@@ -118,7 +118,7 @@ bool __igt_run_subtest(const char *subtest_name);
  * @name: name of the subtest
  *
  * This is a magic control flow block which denotes a subtest code block. Within
- * that codeblock igt_skip|success will only bail out of the subtest. The _f
+ * that code block igt_skip|success will only bail out of the subtest. The _f
  * variant accepts a printf format string, which is useful for constructing
  * combinatorial tests.
  *
@@ -140,7 +140,7 @@ bool __igt_run_subtest(const char *subtest_name);
  * @...: format string and optional arguments
  *
  * This is a magic control flow block which denotes a subtest code block. Within
- * that codeblock igt_skip|success will only bail out of the subtest. The _f
+ * that code block igt_skip|success will only bail out of the subtest. The _f
  * variant accepts a printf format string, which is useful for constructing
  * combinatorial tests.
  *
diff --git a/lib/igt_debugfs.c b/lib/igt_debugfs.c
index 387ffbf..b30f5e4 100644
--- a/lib/igt_debugfs.c
+++ b/lib/igt_debugfs.c
@@ -51,7 +51,7 @@
  * # Pipe CRC Support
  *
  * This library wraps up the kernel's support for capturing pipe CRCs into a
- * neat and tidy package. For the datailed usage see all the functions which
+ * neat and tidy package. For the detailed usage see all the functions which
  * work on #igt_pipe_crc_t. This is supported on all platforms and outputs.
  *
  * Actually using pipe CRCs to write modeset tests is a bit tricky though, so
@@ -59,7 +59,7 @@
  * blending, color correction and other hardware and how exactly the CRC is
  * computed at each tap point vary by hardware generation and are not disclosed.
  *
- * The only way to use #igt_crc_t CRCs therefors is to compare CRCs among each
+ * The only way to use #igt_crc_t CRCs therefore is to compare CRCs among each
  * another either for equality or difference. Otherwise CRCs must be treated as
  * completely opaque values. Note that not even CRCs from different pipes or tap
  * points on the same platform can be compared. Hence only use igt_crc_is_null()
@@ -218,7 +218,7 @@ bool igt_crc_is_null(igt_crc_t *crc)
  *
  * Compares two CRC values.
  *
- * Returns: Retruns true if the two CRCs match, false otherwise.
+ * Returns: true if the two CRCs match, false otherwise.
  */
 bool igt_crc_equal(igt_crc_t *a, igt_crc_t *b)
 {
diff --git a/lib/igt_debugfs.h b/lib/igt_debugfs.h
index 0b55477..adcf83b 100644
--- a/lib/igt_debugfs.h
+++ b/lib/igt_debugfs.h
@@ -153,7 +153,7 @@ int igt_open_forcewake_handle(void);
  * @STOP_RING_RENDER: Render ring
  * @STOP_RING_BSD: Video encoding/decoding ring
  * @STOP_RING_BLT: Blitter ring
- * @STOP_RING_VEBOX: Video enchanment ring
+ * @STOP_RING_VEBOX: Video enhancement ring
  * @STOP_RING_ALL: All rings
  * @STOP_RING_ALLOW_ERRORS: Driver will not omit expected DRM_ERRORS
  * @STOP_RING_ALLOW_BAN: Driver will use context ban policy
diff --git a/lib/igt_kms.h b/lib/igt_kms.h
index 027b4e0..6d05b00 100644
--- a/lib/igt_kms.h
+++ b/lib/igt_kms.h
@@ -70,7 +70,7 @@ enum port {
  * kmstest_port_name:
  * @port: display plane
  *
- * Returns: String represnting @port, e.g. "A".
+ * Returns: String representing @port, e.g. "A".
  */
 #define kmstest_port_name(port) ((port) + 'A')
 
diff --git a/lib/intel_mmio.c b/lib/intel_mmio.c
index c95ae58..5ff1ec1 100644
--- a/lib/intel_mmio.c
+++ b/lib/intel_mmio.c
@@ -53,12 +53,12 @@
  * @include: intel_io.h
  *
  * This library provides register I/O helpers in both a basic version and a more
- * fancy version which also handles forcewak and can optionally check registers
+ * fancy version which also handles forcewake and can optionally check registers
  * against a white-list. All register function are compatible. Hence the same
  * code can be used to decode registers with either of them, or also from a dump
  * file using intel_mmio_use_dump_file().
  *
- * Futhermore this library also provides helper functions for accessing the
+ * Furthermore this library also provides helper functions for accessing the
  * various sideband interfaces found on Valleyview/Baytrail based platforms.
  */
 
@@ -84,7 +84,7 @@ static struct _mmio_data {
  * @file: name of the register dump file to open
  *
  * Sets up #mmio to point at the data contained in @file. This allows the same
- * code to get reused for dumping and decoding from running hardwared as from
+ * code to get reused for dumping and decoding from running hardware as from
  * register dumps.
  */
 void
@@ -109,7 +109,7 @@ intel_mmio_use_dump_file(char *file)
  * @pci_dev: intel gracphis pci device
  *
  * Sets up #mmio to point at the data contained in @file. This allows the same
- * code to get reused for dumping and decoding from running hardwared as from
+ * code to get reused for dumping and decoding from running hardware as from
  * register dumps.
  *
  * @pci_dev can be obtained from intel_get_pci_device().
diff --git a/lib/intel_os.c b/lib/intel_os.c
index 538327a..c8793b9 100644
--- a/lib/intel_os.c
+++ b/lib/intel_os.c
@@ -200,7 +200,7 @@ intel_get_total_swap_mb(void)
  *
  * Computes the total amount of memory required to allocate @count surfaces,
  * each of @size bytes, and includes an estimate for kernel overhead. It then
- * queries the kernel for the avilable amount of memory on the system (either
+ * queries the kernel for the available amount of memory on the system (either
  * RAM and/or SWAP depending upon @mode) and determines whether there is
  * sufficient to run the test.
  *
diff --git a/lib/ioctl_wrappers.c b/lib/ioctl_wrappers.c
index 39afc87..ab1a82e 100644
--- a/lib/ioctl_wrappers.c
+++ b/lib/ioctl_wrappers.c
@@ -506,7 +506,7 @@ void *gem_mmap__cpu(int fd, uint32_t handle, int size, int prot)
  * object is in need again it must be set back to WILLNEED before first use.
  *
  * Returns: When setting the madvise state to WILLNEED this returns whether the
- * backing storage was still avialable or not.
+ * backing storage was still available or not.
  */
 int gem_madvise(int fd, uint32_t handle, int state)
 {
@@ -597,7 +597,7 @@ bool gem_bo_busy(int fd, uint32_t handle)
  * Feature test macro to check whether the kernel internally uses ppgtt to
  * execute batches. The /aliasing/ in the function name is a bit a misnomer,
  * this driver parameter is also true when full ppgtt address spaces are
- * availabel since for batchbuffer construction only ppgtt or global gtt is
+ * available since for batchbuffer construction only ppgtt or global gtt is
  * relevant.
  *
  * Returns: Whether batches are run through ppgtt.
@@ -623,7 +623,7 @@ bool gem_uses_aliasing_ppgtt(int fd)
  * @fd: open i915 drm file descriptor
  *
  * Feature test macro to query the kernel for the number of available fences
- * useable in a batchbuffer. Only relevant for pre-gen4.
+ * usable in a batchbuffer. Only relevant for pre-gen4.
  *
  * Returns: The number of available fences.
  */
@@ -663,7 +663,7 @@ bool gem_has_llc(int fd)
  * gem_get_num_rings:
  * @fd: open i915 drm file descriptor
  *
- * Feature test macro to query the number of avaible rings. This is useful in
+ * Feature test macro to query the number of available rings. This is useful in
  * test loops which need to step through all rings and similar logic.
  *
  * For more explicit tests of ring availability see gem_has_enable_ring() and
@@ -702,7 +702,7 @@ skip:
  *
  * Feature test macro to query whether a specific ring is available.
  *
- * Returns: Whether the ring is avaible or not.
+ * Returns: Whether the ring is available or not.
  */
 bool gem_has_enable_ring(int fd,int param)
 {
@@ -729,7 +729,7 @@ bool gem_has_enable_ring(int fd,int param)
  *
  * Note that recent Bspec calls this the VCS ring for Video Command Submission.
  *
- * Returns: Whether the BSD ring is avaible or not.
+ * Returns: Whether the BSD ring is available or not.
  */
 bool gem_has_bsd(int fd)
 {
@@ -745,7 +745,7 @@ bool gem_has_bsd(int fd)
  *
  * Note that recent Bspec calls this the BCS ring for Blitter Command Submission.
  *
- * Returns: Whether the blitter ring is avaible or not.
+ * Returns: Whether the blitter ring is available or not.
  */
 bool gem_has_blt(int fd)
 {
@@ -763,7 +763,7 @@ bool gem_has_blt(int fd)
  * Note that recent Bspec calls this the VECS ring for Video Enhancement Command
  * Submission.
  *
- * Returns: Whether the vebox ring is avaible or not.
+ * Returns: Whether the vebox ring is available or not.
  */
 bool gem_has_vebox(int fd)
 {
@@ -775,7 +775,7 @@ bool gem_has_vebox(int fd)
  * @fd: open i915 drm file descriptor
  *
  * Feature test macro to query the kernel for the available gpu aperture size
- * useable in a batchbuffer.
+ * usable in a batchbuffer.
  *
  * Returns: The available gtt address space size.
  */
@@ -814,7 +814,7 @@ uint64_t gem_aperture_size(int fd)
  * @fd: open i915 drm file descriptor
  *
  * Feature test macro to query the kernel for the mappable gpu aperture size.
- * This is the area avaialble for GTT memory mappings.
+ * This is the area available for GTT memory mappings.
  *
  * Returns: The mappable gtt address space size.
  */